package dsl.datamodel.parser.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.parser.antlr.Lexer;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDatamodelLexer extends Lexer {
    public static final int RULE_ID=5;
    public static final int RULE_WS=12;
    public static final int RULE_STRING=9;
    public static final int RULE_ANY_OTHER=13;
    public static final int RULE_CTXT_FQN=4;
    public static final int RULE_SL_COMMENT=11;
    public static final int RULE_VERSION=8;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int RULE_INT=7;
    public static final int T__18=18;
    public static final int RULE_GENERAL_FQN=6;
    public static final int RULE_ML_COMMENT=10;
    public static final int T__14=14;
    public static final int EOF=-1;

    // delegates
    // delegators

    public InternalDatamodelLexer() {;} 
    public InternalDatamodelLexer(CharStream input) {
        this(input, new RecognizerSharedState());
    }
    public InternalDatamodelLexer(CharStream input, RecognizerSharedState state) {
        super(input,state);

    }
    public String getGrammarFileName() { return "InternalDatamodel.g"; }

    // $ANTLR start "T__14"
    public final void mT__14() throws RecognitionException {
        try {
            int _type = T__14;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:11:7: ( 'context' )
            // InternalDatamodel.g:11:9: 'context'
            {
            match("context"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__14"

    // $ANTLR start "T__15"
    public final void mT__15() throws RecognitionException {
        try {
            int _type = T__15;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:12:7: ( 'extends' )
            // InternalDatamodel.g:12:9: 'extends'
            {
            match("extends"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__15"

    // $ANTLR start "T__16"
    public final void mT__16() throws RecognitionException {
        try {
            int _type = T__16;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:13:7: ( '{' )
            // InternalDatamodel.g:13:9: '{'
            {
            match('{'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__16"

    // $ANTLR start "T__17"
    public final void mT__17() throws RecognitionException {
        try {
            int _type = T__17;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:14:7: ( 'entity-catalog' )
            // InternalDatamodel.g:14:9: 'entity-catalog'
            {
            match("entity-catalog"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__17"

    // $ANTLR start "T__18"
    public final void mT__18() throws RecognitionException {
        try {
            int _type = T__18;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:15:7: ( '}' )
            // InternalDatamodel.g:15:9: '}'
            {
            match('}'); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "T__18"

    // $ANTLR start "RULE_VERSION"
    public final void mRULE_VERSION() throws RecognitionException {
        try {
            // InternalDatamodel.g:220:23: ( RULE_INT '.' RULE_INT '.' RULE_INT ( '.' RULE_INT )? )
            // InternalDatamodel.g:220:25: RULE_INT '.' RULE_INT '.' RULE_INT ( '.' RULE_INT )?
            {
            mRULE_INT(); 
            match('.'); 
            mRULE_INT(); 
            match('.'); 
            mRULE_INT(); 
            // InternalDatamodel.g:220:60: ( '.' RULE_INT )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0=='.') ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // InternalDatamodel.g:220:61: '.' RULE_INT
                    {
                    match('.'); 
                    mRULE_INT(); 

                    }
                    break;

            }


            }

        }
        finally {
        }
    }
    // $ANTLR end "RULE_VERSION"

    // $ANTLR start "RULE_CTXT_FQN"
    public final void mRULE_CTXT_FQN() throws RecognitionException {
        try {
            int _type = RULE_CTXT_FQN;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:222:15: ( RULE_ID '-' RULE_VERSION )
            // InternalDatamodel.g:222:17: RULE_ID '-' RULE_VERSION
            {
            mRULE_ID(); 
            match('-'); 
            mRULE_VERSION(); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_CTXT_FQN"

    // $ANTLR start "RULE_GENERAL_FQN"
    public final void mRULE_GENERAL_FQN() throws RecognitionException {
        try {
            int _type = RULE_GENERAL_FQN;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:224:18: ( RULE_CTXT_FQN '.' RULE_ID )
            // InternalDatamodel.g:224:20: RULE_CTXT_FQN '.' RULE_ID
            {
            mRULE_CTXT_FQN(); 
            match('.'); 
            mRULE_ID(); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_GENERAL_FQN"

    // $ANTLR start "RULE_ID"
    public final void mRULE_ID() throws RecognitionException {
        try {
            int _type = RULE_ID;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:226:9: ( ( '^' )? ( 'a' .. 'z' | 'A' .. 'Z' | '_' ) ( 'a' .. 'z' | 'A' .. 'Z' | '_' | '0' .. '9' )* )
            // InternalDatamodel.g:226:11: ( '^' )? ( 'a' .. 'z' | 'A' .. 'Z' | '_' ) ( 'a' .. 'z' | 'A' .. 'Z' | '_' | '0' .. '9' )*
            {
            // InternalDatamodel.g:226:11: ( '^' )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0=='^') ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // InternalDatamodel.g:226:11: '^'
                    {
                    match('^'); 

                    }
                    break;

            }

            if ( (input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
                input.consume();

            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                recover(mse);
                throw mse;}

            // InternalDatamodel.g:226:40: ( 'a' .. 'z' | 'A' .. 'Z' | '_' | '0' .. '9' )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( ((LA3_0>='0' && LA3_0<='9')||(LA3_0>='A' && LA3_0<='Z')||LA3_0=='_'||(LA3_0>='a' && LA3_0<='z')) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // InternalDatamodel.g:
            	    {
            	    if ( (input.LA(1)>='0' && input.LA(1)<='9')||(input.LA(1)>='A' && input.LA(1)<='Z')||input.LA(1)=='_'||(input.LA(1)>='a' && input.LA(1)<='z') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_ID"

    // $ANTLR start "RULE_INT"
    public final void mRULE_INT() throws RecognitionException {
        try {
            // InternalDatamodel.g:228:19: ( ( '0' .. '9' )+ )
            // InternalDatamodel.g:228:21: ( '0' .. '9' )+
            {
            // InternalDatamodel.g:228:21: ( '0' .. '9' )+
            int cnt4=0;
            loop4:
            do {
                int alt4=2;
                int LA4_0 = input.LA(1);

                if ( ((LA4_0>='0' && LA4_0<='9')) ) {
                    alt4=1;
                }


                switch (alt4) {
            	case 1 :
            	    // InternalDatamodel.g:228:22: '0' .. '9'
            	    {
            	    matchRange('0','9'); 

            	    }
            	    break;

            	default :
            	    if ( cnt4 >= 1 ) break loop4;
                        EarlyExitException eee =
                            new EarlyExitException(4, input);
                        throw eee;
                }
                cnt4++;
            } while (true);


            }

        }
        finally {
        }
    }
    // $ANTLR end "RULE_INT"

    // $ANTLR start "RULE_STRING"
    public final void mRULE_STRING() throws RecognitionException {
        try {
            int _type = RULE_STRING;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:230:13: ( ( '\"' ( '\\\\' . | ~ ( ( '\\\\' | '\"' ) ) )* '\"' | '\\'' ( '\\\\' . | ~ ( ( '\\\\' | '\\'' ) ) )* '\\'' ) )
            // InternalDatamodel.g:230:15: ( '\"' ( '\\\\' . | ~ ( ( '\\\\' | '\"' ) ) )* '\"' | '\\'' ( '\\\\' . | ~ ( ( '\\\\' | '\\'' ) ) )* '\\'' )
            {
            // InternalDatamodel.g:230:15: ( '\"' ( '\\\\' . | ~ ( ( '\\\\' | '\"' ) ) )* '\"' | '\\'' ( '\\\\' . | ~ ( ( '\\\\' | '\\'' ) ) )* '\\'' )
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0=='\"') ) {
                alt7=1;
            }
            else if ( (LA7_0=='\'') ) {
                alt7=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }
            switch (alt7) {
                case 1 :
                    // InternalDatamodel.g:230:16: '\"' ( '\\\\' . | ~ ( ( '\\\\' | '\"' ) ) )* '\"'
                    {
                    match('\"'); 
                    // InternalDatamodel.g:230:20: ( '\\\\' . | ~ ( ( '\\\\' | '\"' ) ) )*
                    loop5:
                    do {
                        int alt5=3;
                        int LA5_0 = input.LA(1);

                        if ( (LA5_0=='\\') ) {
                            alt5=1;
                        }
                        else if ( ((LA5_0>='\u0000' && LA5_0<='!')||(LA5_0>='#' && LA5_0<='[')||(LA5_0>=']' && LA5_0<='\uFFFF')) ) {
                            alt5=2;
                        }


                        switch (alt5) {
                    	case 1 :
                    	    // InternalDatamodel.g:230:21: '\\\\' .
                    	    {
                    	    match('\\'); 
                    	    matchAny(); 

                    	    }
                    	    break;
                    	case 2 :
                    	    // InternalDatamodel.g:230:28: ~ ( ( '\\\\' | '\"' ) )
                    	    {
                    	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='!')||(input.LA(1)>='#' && input.LA(1)<='[')||(input.LA(1)>=']' && input.LA(1)<='\uFFFF') ) {
                    	        input.consume();

                    	    }
                    	    else {
                    	        MismatchedSetException mse = new MismatchedSetException(null,input);
                    	        recover(mse);
                    	        throw mse;}


                    	    }
                    	    break;

                    	default :
                    	    break loop5;
                        }
                    } while (true);

                    match('\"'); 

                    }
                    break;
                case 2 :
                    // InternalDatamodel.g:230:48: '\\'' ( '\\\\' . | ~ ( ( '\\\\' | '\\'' ) ) )* '\\''
                    {
                    match('\''); 
                    // InternalDatamodel.g:230:53: ( '\\\\' . | ~ ( ( '\\\\' | '\\'' ) ) )*
                    loop6:
                    do {
                        int alt6=3;
                        int LA6_0 = input.LA(1);

                        if ( (LA6_0=='\\') ) {
                            alt6=1;
                        }
                        else if ( ((LA6_0>='\u0000' && LA6_0<='&')||(LA6_0>='(' && LA6_0<='[')||(LA6_0>=']' && LA6_0<='\uFFFF')) ) {
                            alt6=2;
                        }


                        switch (alt6) {
                    	case 1 :
                    	    // InternalDatamodel.g:230:54: '\\\\' .
                    	    {
                    	    match('\\'); 
                    	    matchAny(); 

                    	    }
                    	    break;
                    	case 2 :
                    	    // InternalDatamodel.g:230:61: ~ ( ( '\\\\' | '\\'' ) )
                    	    {
                    	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='&')||(input.LA(1)>='(' && input.LA(1)<='[')||(input.LA(1)>=']' && input.LA(1)<='\uFFFF') ) {
                    	        input.consume();

                    	    }
                    	    else {
                    	        MismatchedSetException mse = new MismatchedSetException(null,input);
                    	        recover(mse);
                    	        throw mse;}


                    	    }
                    	    break;

                    	default :
                    	    break loop6;
                        }
                    } while (true);

                    match('\''); 

                    }
                    break;

            }


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_STRING"

    // $ANTLR start "RULE_ML_COMMENT"
    public final void mRULE_ML_COMMENT() throws RecognitionException {
        try {
            int _type = RULE_ML_COMMENT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:232:17: ( '/*' ( options {greedy=false; } : . )* '*/' )
            // InternalDatamodel.g:232:19: '/*' ( options {greedy=false; } : . )* '*/'
            {
            match("/*"); 

            // InternalDatamodel.g:232:24: ( options {greedy=false; } : . )*
            loop8:
            do {
                int alt8=2;
                int LA8_0 = input.LA(1);

                if ( (LA8_0=='*') ) {
                    int LA8_1 = input.LA(2);

                    if ( (LA8_1=='/') ) {
                        alt8=2;
                    }
                    else if ( ((LA8_1>='\u0000' && LA8_1<='.')||(LA8_1>='0' && LA8_1<='\uFFFF')) ) {
                        alt8=1;
                    }


                }
                else if ( ((LA8_0>='\u0000' && LA8_0<=')')||(LA8_0>='+' && LA8_0<='\uFFFF')) ) {
                    alt8=1;
                }


                switch (alt8) {
            	case 1 :
            	    // InternalDatamodel.g:232:52: .
            	    {
            	    matchAny(); 

            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);

            match("*/"); 


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_ML_COMMENT"

    // $ANTLR start "RULE_SL_COMMENT"
    public final void mRULE_SL_COMMENT() throws RecognitionException {
        try {
            int _type = RULE_SL_COMMENT;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:234:17: ( '//' (~ ( ( '\\n' | '\\r' ) ) )* ( ( '\\r' )? '\\n' )? )
            // InternalDatamodel.g:234:19: '//' (~ ( ( '\\n' | '\\r' ) ) )* ( ( '\\r' )? '\\n' )?
            {
            match("//"); 

            // InternalDatamodel.g:234:24: (~ ( ( '\\n' | '\\r' ) ) )*
            loop9:
            do {
                int alt9=2;
                int LA9_0 = input.LA(1);

                if ( ((LA9_0>='\u0000' && LA9_0<='\t')||(LA9_0>='\u000B' && LA9_0<='\f')||(LA9_0>='\u000E' && LA9_0<='\uFFFF')) ) {
                    alt9=1;
                }


                switch (alt9) {
            	case 1 :
            	    // InternalDatamodel.g:234:24: ~ ( ( '\\n' | '\\r' ) )
            	    {
            	    if ( (input.LA(1)>='\u0000' && input.LA(1)<='\t')||(input.LA(1)>='\u000B' && input.LA(1)<='\f')||(input.LA(1)>='\u000E' && input.LA(1)<='\uFFFF') ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    break loop9;
                }
            } while (true);

            // InternalDatamodel.g:234:40: ( ( '\\r' )? '\\n' )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0=='\n'||LA11_0=='\r') ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // InternalDatamodel.g:234:41: ( '\\r' )? '\\n'
                    {
                    // InternalDatamodel.g:234:41: ( '\\r' )?
                    int alt10=2;
                    int LA10_0 = input.LA(1);

                    if ( (LA10_0=='\r') ) {
                        alt10=1;
                    }
                    switch (alt10) {
                        case 1 :
                            // InternalDatamodel.g:234:41: '\\r'
                            {
                            match('\r'); 

                            }
                            break;

                    }

                    match('\n'); 

                    }
                    break;

            }


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_SL_COMMENT"

    // $ANTLR start "RULE_WS"
    public final void mRULE_WS() throws RecognitionException {
        try {
            int _type = RULE_WS;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:236:9: ( ( ' ' | '\\t' | '\\r' | '\\n' )+ )
            // InternalDatamodel.g:236:11: ( ' ' | '\\t' | '\\r' | '\\n' )+
            {
            // InternalDatamodel.g:236:11: ( ' ' | '\\t' | '\\r' | '\\n' )+
            int cnt12=0;
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( ((LA12_0>='\t' && LA12_0<='\n')||LA12_0=='\r'||LA12_0==' ') ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // InternalDatamodel.g:
            	    {
            	    if ( (input.LA(1)>='\t' && input.LA(1)<='\n')||input.LA(1)=='\r'||input.LA(1)==' ' ) {
            	        input.consume();

            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        recover(mse);
            	        throw mse;}


            	    }
            	    break;

            	default :
            	    if ( cnt12 >= 1 ) break loop12;
                        EarlyExitException eee =
                            new EarlyExitException(12, input);
                        throw eee;
                }
                cnt12++;
            } while (true);


            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_WS"

    // $ANTLR start "RULE_ANY_OTHER"
    public final void mRULE_ANY_OTHER() throws RecognitionException {
        try {
            int _type = RULE_ANY_OTHER;
            int _channel = DEFAULT_TOKEN_CHANNEL;
            // InternalDatamodel.g:238:16: ( . )
            // InternalDatamodel.g:238:18: .
            {
            matchAny(); 

            }

            state.type = _type;
            state.channel = _channel;
        }
        finally {
        }
    }
    // $ANTLR end "RULE_ANY_OTHER"

    public void mTokens() throws RecognitionException {
        // InternalDatamodel.g:1:8: ( T__14 | T__15 | T__16 | T__17 | T__18 | RULE_CTXT_FQN | RULE_GENERAL_FQN | RULE_ID | RULE_STRING | RULE_ML_COMMENT | RULE_SL_COMMENT | RULE_WS | RULE_ANY_OTHER )
        int alt13=13;
        alt13 = dfa13.predict(input);
        switch (alt13) {
            case 1 :
                // InternalDatamodel.g:1:10: T__14
                {
                mT__14(); 

                }
                break;
            case 2 :
                // InternalDatamodel.g:1:16: T__15
                {
                mT__15(); 

                }
                break;
            case 3 :
                // InternalDatamodel.g:1:22: T__16
                {
                mT__16(); 

                }
                break;
            case 4 :
                // InternalDatamodel.g:1:28: T__17
                {
                mT__17(); 

                }
                break;
            case 5 :
                // InternalDatamodel.g:1:34: T__18
                {
                mT__18(); 

                }
                break;
            case 6 :
                // InternalDatamodel.g:1:40: RULE_CTXT_FQN
                {
                mRULE_CTXT_FQN(); 

                }
                break;
            case 7 :
                // InternalDatamodel.g:1:54: RULE_GENERAL_FQN
                {
                mRULE_GENERAL_FQN(); 

                }
                break;
            case 8 :
                // InternalDatamodel.g:1:71: RULE_ID
                {
                mRULE_ID(); 

                }
                break;
            case 9 :
                // InternalDatamodel.g:1:79: RULE_STRING
                {
                mRULE_STRING(); 

                }
                break;
            case 10 :
                // InternalDatamodel.g:1:91: RULE_ML_COMMENT
                {
                mRULE_ML_COMMENT(); 

                }
                break;
            case 11 :
                // InternalDatamodel.g:1:107: RULE_SL_COMMENT
                {
                mRULE_SL_COMMENT(); 

                }
                break;
            case 12 :
                // InternalDatamodel.g:1:123: RULE_WS
                {
                mRULE_WS(); 

                }
                break;
            case 13 :
                // InternalDatamodel.g:1:131: RULE_ANY_OTHER
                {
                mRULE_ANY_OTHER(); 

                }
                break;

        }

    }


    protected DFA13 dfa13 = new DFA13(this);
    static final String DFA13_eotS =
        "\1\uffff\2\16\2\uffff\1\13\1\16\3\13\2\uffff\2\16\2\uffff\2\16\2\uffff\1\16\4\uffff\1\16\1\uffff\3\16\1\uffff\3\16\1\uffff\3\16\1\uffff\2\16\1\55\1\56\1\60\6\uffff\1\56\1\uffff";
    static final String DFA13_eofS =
        "\64\uffff";
    static final String DFA13_minS =
        "\1\0\2\55\2\uffff\1\101\1\55\2\0\1\52\2\uffff\2\55\1\uffff\1\60\2\55\2\uffff\1\55\4\uffff\1\55\1\56\3\55\1\60\3\55\1\56\3\55\1\60\3\55\1\56\1\55\1\60\2\uffff\1\60\2\uffff\1\56\1\uffff";
    static final String DFA13_maxS =
        "\1\uffff\2\172\2\uffff\2\172\2\uffff\1\57\2\uffff\2\172\1\uffff\1\71\2\172\2\uffff\1\172\4\uffff\1\172\1\71\3\172\1\71\3\172\1\71\3\172\1\71\3\172\1\71\1\172\1\143\2\uffff\1\172\2\uffff\1\71\1\uffff";
    static final String DFA13_acceptS =
        "\3\uffff\1\3\1\5\5\uffff\1\14\1\15\2\uffff\1\10\3\uffff\1\3\1\5\1\uffff\1\11\1\12\1\13\1\14\24\uffff\1\1\1\6\1\uffff\1\2\1\4\1\uffff\1\7";
    static final String DFA13_specialS =
        "\1\2\6\uffff\1\0\1\1\53\uffff}>";
    static final String[] DFA13_transitionS = {
            "\11\13\2\12\2\13\1\12\22\13\1\12\1\13\1\7\4\13\1\10\7\13\1\11\21\13\32\6\3\13\1\5\1\6\1\13\2\6\1\1\1\6\1\2\25\6\1\3\1\13\1\4\uff82\13",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\16\15\1\14\13\15",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\15\15\1\21\11\15\1\20\2\15",
            "",
            "",
            "\32\24\4\uffff\1\24\1\uffff\32\24",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15",
            "\0\25",
            "\0\25",
            "\1\26\4\uffff\1\27",
            "",
            "",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\15\15\1\31\14\15",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15",
            "",
            "\12\32",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\23\15\1\33\6\15",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\23\15\1\34\6\15",
            "",
            "",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15",
            "",
            "",
            "",
            "",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\23\15\1\35\6\15",
            "\1\36\1\uffff\12\32",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\4\15\1\37\25\15",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\10\15\1\40\21\15",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\4\15\1\41\25\15",
            "\12\42",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\15\15\1\43\14\15",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\23\15\1\44\6\15",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\27\15\1\45\2\15",
            "\1\46\1\uffff\12\42",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\3\15\1\47\26\15",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\30\15\1\50\1\15",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\23\15\1\51\6\15",
            "\12\52",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\22\15\1\53\7\15",
            "\1\54\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15",
            "\1\57\1\uffff\12\52",
            "\1\17\2\uffff\12\15\7\uffff\32\15\4\uffff\1\15\1\uffff\32\15",
            "\12\32\51\uffff\1\61",
            "",
            "",
            "\12\62\7\uffff\32\63\3\uffff\2\63\1\uffff\32\63",
            "",
            "",
            "\1\63\1\uffff\12\62",
            ""
    };

    static final short[] DFA13_eot = DFA.unpackEncodedString(DFA13_eotS);
    static final short[] DFA13_eof = DFA.unpackEncodedString(DFA13_eofS);
    static final char[] DFA13_min = DFA.unpackEncodedStringToUnsignedChars(DFA13_minS);
    static final char[] DFA13_max = DFA.unpackEncodedStringToUnsignedChars(DFA13_maxS);
    static final short[] DFA13_accept = DFA.unpackEncodedString(DFA13_acceptS);
    static final short[] DFA13_special = DFA.unpackEncodedString(DFA13_specialS);
    static final short[][] DFA13_transition;

    static {
        int numStates = DFA13_transitionS.length;
        DFA13_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA13_transition[i] = DFA.unpackEncodedString(DFA13_transitionS[i]);
        }
    }

    class DFA13 extends DFA {

        public DFA13(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 13;
            this.eot = DFA13_eot;
            this.eof = DFA13_eof;
            this.min = DFA13_min;
            this.max = DFA13_max;
            this.accept = DFA13_accept;
            this.special = DFA13_special;
            this.transition = DFA13_transition;
        }
        public String getDescription() {
            return "1:1: Tokens : ( T__14 | T__15 | T__16 | T__17 | T__18 | RULE_CTXT_FQN | RULE_GENERAL_FQN | RULE_ID | RULE_STRING | RULE_ML_COMMENT | RULE_SL_COMMENT | RULE_WS | RULE_ANY_OTHER );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            IntStream input = _input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA13_7 = input.LA(1);

                        s = -1;
                        if ( ((LA13_7>='\u0000' && LA13_7<='\uFFFF')) ) {s = 21;}

                        else s = 11;

                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA13_8 = input.LA(1);

                        s = -1;
                        if ( ((LA13_8>='\u0000' && LA13_8<='\uFFFF')) ) {s = 21;}

                        else s = 11;

                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA13_0 = input.LA(1);

                        s = -1;
                        if ( (LA13_0=='c') ) {s = 1;}

                        else if ( (LA13_0=='e') ) {s = 2;}

                        else if ( (LA13_0=='{') ) {s = 3;}

                        else if ( (LA13_0=='}') ) {s = 4;}

                        else if ( (LA13_0=='^') ) {s = 5;}

                        else if ( ((LA13_0>='A' && LA13_0<='Z')||LA13_0=='_'||(LA13_0>='a' && LA13_0<='b')||LA13_0=='d'||(LA13_0>='f' && LA13_0<='z')) ) {s = 6;}

                        else if ( (LA13_0=='\"') ) {s = 7;}

                        else if ( (LA13_0=='\'') ) {s = 8;}

                        else if ( (LA13_0=='/') ) {s = 9;}

                        else if ( ((LA13_0>='\t' && LA13_0<='\n')||LA13_0=='\r'||LA13_0==' ') ) {s = 10;}

                        else if ( ((LA13_0>='\u0000' && LA13_0<='\b')||(LA13_0>='\u000B' && LA13_0<='\f')||(LA13_0>='\u000E' && LA13_0<='\u001F')||LA13_0=='!'||(LA13_0>='#' && LA13_0<='&')||(LA13_0>='(' && LA13_0<='.')||(LA13_0>='0' && LA13_0<='@')||(LA13_0>='[' && LA13_0<=']')||LA13_0=='`'||LA13_0=='|'||(LA13_0>='~' && LA13_0<='\uFFFF')) ) {s = 11;}

                        if ( s>=0 ) return s;
                        break;
            }
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 13, _s, input);
            error(nvae);
            throw nvae;
        }
    }
 

}