package dsl.datamodel.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import dsl.datamodel.services.DatamodelGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDatamodelParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_CTXT_FQN", "RULE_ID", "RULE_GENERAL_FQN", "RULE_INT", "RULE_VERSION", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'context'", "'extends'", "'{'", "'entity-catalog'", "'}'"
    };
    public static final int RULE_ID=5;
    public static final int RULE_WS=12;
    public static final int RULE_STRING=9;
    public static final int RULE_ANY_OTHER=13;
    public static final int RULE_CTXT_FQN=4;
    public static final int RULE_SL_COMMENT=11;
    public static final int RULE_VERSION=8;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int RULE_INT=7;
    public static final int T__18=18;
    public static final int RULE_GENERAL_FQN=6;
    public static final int RULE_ML_COMMENT=10;
    public static final int T__14=14;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalDatamodelParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDatamodelParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDatamodelParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDatamodel.g"; }



     	private DatamodelGrammarAccess grammarAccess;

        public InternalDatamodelParser(TokenStream input, DatamodelGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "Context";
       	}

       	@Override
       	protected DatamodelGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleContext"
    // InternalDatamodel.g:64:1: entryRuleContext returns [EObject current=null] : iv_ruleContext= ruleContext EOF ;
    public final EObject entryRuleContext() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleContext = null;


        try {
            // InternalDatamodel.g:64:48: (iv_ruleContext= ruleContext EOF )
            // InternalDatamodel.g:65:2: iv_ruleContext= ruleContext EOF
            {
             newCompositeNode(grammarAccess.getContextRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleContext=ruleContext();

            state._fsp--;

             current =iv_ruleContext; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleContext"


    // $ANTLR start "ruleContext"
    // InternalDatamodel.g:71:1: ruleContext returns [EObject current=null] : (otherlv_0= 'context' ( (lv_name_1_0= RULE_CTXT_FQN ) ) (otherlv_2= 'extends' ( (otherlv_3= RULE_CTXT_FQN ) ) )? otherlv_4= '{' (otherlv_5= 'entity-catalog' otherlv_6= '{' ( (lv_entities_7_0= ruleEntity ) )* otherlv_8= '}' )? otherlv_9= '}' ) ;
    public final EObject ruleContext() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_8=null;
        Token otherlv_9=null;
        EObject lv_entities_7_0 = null;



        	enterRule();

        try {
            // InternalDatamodel.g:77:2: ( (otherlv_0= 'context' ( (lv_name_1_0= RULE_CTXT_FQN ) ) (otherlv_2= 'extends' ( (otherlv_3= RULE_CTXT_FQN ) ) )? otherlv_4= '{' (otherlv_5= 'entity-catalog' otherlv_6= '{' ( (lv_entities_7_0= ruleEntity ) )* otherlv_8= '}' )? otherlv_9= '}' ) )
            // InternalDatamodel.g:78:2: (otherlv_0= 'context' ( (lv_name_1_0= RULE_CTXT_FQN ) ) (otherlv_2= 'extends' ( (otherlv_3= RULE_CTXT_FQN ) ) )? otherlv_4= '{' (otherlv_5= 'entity-catalog' otherlv_6= '{' ( (lv_entities_7_0= ruleEntity ) )* otherlv_8= '}' )? otherlv_9= '}' )
            {
            // InternalDatamodel.g:78:2: (otherlv_0= 'context' ( (lv_name_1_0= RULE_CTXT_FQN ) ) (otherlv_2= 'extends' ( (otherlv_3= RULE_CTXT_FQN ) ) )? otherlv_4= '{' (otherlv_5= 'entity-catalog' otherlv_6= '{' ( (lv_entities_7_0= ruleEntity ) )* otherlv_8= '}' )? otherlv_9= '}' )
            // InternalDatamodel.g:79:3: otherlv_0= 'context' ( (lv_name_1_0= RULE_CTXT_FQN ) ) (otherlv_2= 'extends' ( (otherlv_3= RULE_CTXT_FQN ) ) )? otherlv_4= '{' (otherlv_5= 'entity-catalog' otherlv_6= '{' ( (lv_entities_7_0= ruleEntity ) )* otherlv_8= '}' )? otherlv_9= '}'
            {
            otherlv_0=(Token)match(input,14,FOLLOW_3); 

            			newLeafNode(otherlv_0, grammarAccess.getContextAccess().getContextKeyword_0());
            		
            // InternalDatamodel.g:83:3: ( (lv_name_1_0= RULE_CTXT_FQN ) )
            // InternalDatamodel.g:84:4: (lv_name_1_0= RULE_CTXT_FQN )
            {
            // InternalDatamodel.g:84:4: (lv_name_1_0= RULE_CTXT_FQN )
            // InternalDatamodel.g:85:5: lv_name_1_0= RULE_CTXT_FQN
            {
            lv_name_1_0=(Token)match(input,RULE_CTXT_FQN,FOLLOW_4); 

            					newLeafNode(lv_name_1_0, grammarAccess.getContextAccess().getNameCTXT_FQNTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getContextRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_1_0,
            						"dsl.datamodel.Datamodel.CTXT_FQN");
            				

            }


            }

            // InternalDatamodel.g:101:3: (otherlv_2= 'extends' ( (otherlv_3= RULE_CTXT_FQN ) ) )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==15) ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // InternalDatamodel.g:102:4: otherlv_2= 'extends' ( (otherlv_3= RULE_CTXT_FQN ) )
                    {
                    otherlv_2=(Token)match(input,15,FOLLOW_3); 

                    				newLeafNode(otherlv_2, grammarAccess.getContextAccess().getExtendsKeyword_2_0());
                    			
                    // InternalDatamodel.g:106:4: ( (otherlv_3= RULE_CTXT_FQN ) )
                    // InternalDatamodel.g:107:5: (otherlv_3= RULE_CTXT_FQN )
                    {
                    // InternalDatamodel.g:107:5: (otherlv_3= RULE_CTXT_FQN )
                    // InternalDatamodel.g:108:6: otherlv_3= RULE_CTXT_FQN
                    {

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getContextRule());
                    						}
                    					
                    otherlv_3=(Token)match(input,RULE_CTXT_FQN,FOLLOW_5); 

                    						newLeafNode(otherlv_3, grammarAccess.getContextAccess().getParentContextContextCrossReference_2_1_0());
                    					

                    }


                    }


                    }
                    break;

            }

            otherlv_4=(Token)match(input,16,FOLLOW_6); 

            			newLeafNode(otherlv_4, grammarAccess.getContextAccess().getLeftCurlyBracketKeyword_3());
            		
            // InternalDatamodel.g:124:3: (otherlv_5= 'entity-catalog' otherlv_6= '{' ( (lv_entities_7_0= ruleEntity ) )* otherlv_8= '}' )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==17) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // InternalDatamodel.g:125:4: otherlv_5= 'entity-catalog' otherlv_6= '{' ( (lv_entities_7_0= ruleEntity ) )* otherlv_8= '}'
                    {
                    otherlv_5=(Token)match(input,17,FOLLOW_5); 

                    				newLeafNode(otherlv_5, grammarAccess.getContextAccess().getEntityCatalogKeyword_4_0());
                    			
                    otherlv_6=(Token)match(input,16,FOLLOW_7); 

                    				newLeafNode(otherlv_6, grammarAccess.getContextAccess().getLeftCurlyBracketKeyword_4_1());
                    			
                    // InternalDatamodel.g:133:4: ( (lv_entities_7_0= ruleEntity ) )*
                    loop2:
                    do {
                        int alt2=2;
                        int LA2_0 = input.LA(1);

                        if ( (LA2_0==RULE_ID) ) {
                            alt2=1;
                        }


                        switch (alt2) {
                    	case 1 :
                    	    // InternalDatamodel.g:134:5: (lv_entities_7_0= ruleEntity )
                    	    {
                    	    // InternalDatamodel.g:134:5: (lv_entities_7_0= ruleEntity )
                    	    // InternalDatamodel.g:135:6: lv_entities_7_0= ruleEntity
                    	    {

                    	    						newCompositeNode(grammarAccess.getContextAccess().getEntitiesEntityParserRuleCall_4_2_0());
                    	    					
                    	    pushFollow(FOLLOW_7);
                    	    lv_entities_7_0=ruleEntity();

                    	    state._fsp--;


                    	    						if (current==null) {
                    	    							current = createModelElementForParent(grammarAccess.getContextRule());
                    	    						}
                    	    						add(
                    	    							current,
                    	    							"entities",
                    	    							lv_entities_7_0,
                    	    							"dsl.datamodel.Datamodel.Entity");
                    	    						afterParserOrEnumRuleCall();
                    	    					

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop2;
                        }
                    } while (true);

                    otherlv_8=(Token)match(input,18,FOLLOW_8); 

                    				newLeafNode(otherlv_8, grammarAccess.getContextAccess().getRightCurlyBracketKeyword_4_3());
                    			

                    }
                    break;

            }

            otherlv_9=(Token)match(input,18,FOLLOW_2); 

            			newLeafNode(otherlv_9, grammarAccess.getContextAccess().getRightCurlyBracketKeyword_5());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleContext"


    // $ANTLR start "entryRuleEntity"
    // InternalDatamodel.g:165:1: entryRuleEntity returns [EObject current=null] : iv_ruleEntity= ruleEntity EOF ;
    public final EObject entryRuleEntity() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEntity = null;


        try {
            // InternalDatamodel.g:165:47: (iv_ruleEntity= ruleEntity EOF )
            // InternalDatamodel.g:166:2: iv_ruleEntity= ruleEntity EOF
            {
             newCompositeNode(grammarAccess.getEntityRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleEntity=ruleEntity();

            state._fsp--;

             current =iv_ruleEntity; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEntity"


    // $ANTLR start "ruleEntity"
    // InternalDatamodel.g:172:1: ruleEntity returns [EObject current=null] : ( ( (lv_name_0_0= RULE_ID ) ) (otherlv_1= 'extends' ( (otherlv_2= RULE_GENERAL_FQN ) ) )? ) ;
    public final EObject ruleEntity() throws RecognitionException {
        EObject current = null;

        Token lv_name_0_0=null;
        Token otherlv_1=null;
        Token otherlv_2=null;


        	enterRule();

        try {
            // InternalDatamodel.g:178:2: ( ( ( (lv_name_0_0= RULE_ID ) ) (otherlv_1= 'extends' ( (otherlv_2= RULE_GENERAL_FQN ) ) )? ) )
            // InternalDatamodel.g:179:2: ( ( (lv_name_0_0= RULE_ID ) ) (otherlv_1= 'extends' ( (otherlv_2= RULE_GENERAL_FQN ) ) )? )
            {
            // InternalDatamodel.g:179:2: ( ( (lv_name_0_0= RULE_ID ) ) (otherlv_1= 'extends' ( (otherlv_2= RULE_GENERAL_FQN ) ) )? )
            // InternalDatamodel.g:180:3: ( (lv_name_0_0= RULE_ID ) ) (otherlv_1= 'extends' ( (otherlv_2= RULE_GENERAL_FQN ) ) )?
            {
            // InternalDatamodel.g:180:3: ( (lv_name_0_0= RULE_ID ) )
            // InternalDatamodel.g:181:4: (lv_name_0_0= RULE_ID )
            {
            // InternalDatamodel.g:181:4: (lv_name_0_0= RULE_ID )
            // InternalDatamodel.g:182:5: lv_name_0_0= RULE_ID
            {
            lv_name_0_0=(Token)match(input,RULE_ID,FOLLOW_9); 

            					newLeafNode(lv_name_0_0, grammarAccess.getEntityAccess().getNameIDTerminalRuleCall_0_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getEntityRule());
            					}
            					setWithLastConsumed(
            						current,
            						"name",
            						lv_name_0_0,
            						"org.eclipse.xtext.common.Terminals.ID");
            				

            }


            }

            // InternalDatamodel.g:198:3: (otherlv_1= 'extends' ( (otherlv_2= RULE_GENERAL_FQN ) ) )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==15) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // InternalDatamodel.g:199:4: otherlv_1= 'extends' ( (otherlv_2= RULE_GENERAL_FQN ) )
                    {
                    otherlv_1=(Token)match(input,15,FOLLOW_10); 

                    				newLeafNode(otherlv_1, grammarAccess.getEntityAccess().getExtendsKeyword_1_0());
                    			
                    // InternalDatamodel.g:203:4: ( (otherlv_2= RULE_GENERAL_FQN ) )
                    // InternalDatamodel.g:204:5: (otherlv_2= RULE_GENERAL_FQN )
                    {
                    // InternalDatamodel.g:204:5: (otherlv_2= RULE_GENERAL_FQN )
                    // InternalDatamodel.g:205:6: otherlv_2= RULE_GENERAL_FQN
                    {

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getEntityRule());
                    						}
                    					
                    otherlv_2=(Token)match(input,RULE_GENERAL_FQN,FOLLOW_2); 

                    						newLeafNode(otherlv_2, grammarAccess.getEntityAccess().getParentEntityEntityCrossReference_1_1_0());
                    					

                    }


                    }


                    }
                    break;

            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEntity"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000018000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000060000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000040020L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000008002L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000000040L});

}