package dsl.datamodel.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import dsl.datamodel.services.DatamodelGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDatamodelParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_CTXT_FQN", "RULE_ID", "RULE_GENERAL_FQN", "RULE_INT", "RULE_VERSION", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'context'", "'{'", "'}'", "'extends'", "'entity-catalog'"
    };
    public static final int RULE_ID=5;
    public static final int RULE_WS=12;
    public static final int RULE_STRING=9;
    public static final int RULE_ANY_OTHER=13;
    public static final int RULE_CTXT_FQN=4;
    public static final int RULE_SL_COMMENT=11;
    public static final int RULE_VERSION=8;
    public static final int T__15=15;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int RULE_INT=7;
    public static final int T__18=18;
    public static final int RULE_GENERAL_FQN=6;
    public static final int RULE_ML_COMMENT=10;
    public static final int T__14=14;
    public static final int EOF=-1;

    // delegates
    // delegators


        public InternalDatamodelParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDatamodelParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDatamodelParser.tokenNames; }
    public String getGrammarFileName() { return "InternalDatamodel.g"; }


    	private DatamodelGrammarAccess grammarAccess;

    	public void setGrammarAccess(DatamodelGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleContext"
    // InternalDatamodel.g:53:1: entryRuleContext : ruleContext EOF ;
    public final void entryRuleContext() throws RecognitionException {
        try {
            // InternalDatamodel.g:54:1: ( ruleContext EOF )
            // InternalDatamodel.g:55:1: ruleContext EOF
            {
             before(grammarAccess.getContextRule()); 
            pushFollow(FOLLOW_1);
            ruleContext();

            state._fsp--;

             after(grammarAccess.getContextRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleContext"


    // $ANTLR start "ruleContext"
    // InternalDatamodel.g:62:1: ruleContext : ( ( rule__Context__Group__0 ) ) ;
    public final void ruleContext() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:66:2: ( ( ( rule__Context__Group__0 ) ) )
            // InternalDatamodel.g:67:2: ( ( rule__Context__Group__0 ) )
            {
            // InternalDatamodel.g:67:2: ( ( rule__Context__Group__0 ) )
            // InternalDatamodel.g:68:3: ( rule__Context__Group__0 )
            {
             before(grammarAccess.getContextAccess().getGroup()); 
            // InternalDatamodel.g:69:3: ( rule__Context__Group__0 )
            // InternalDatamodel.g:69:4: rule__Context__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Context__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getContextAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleContext"


    // $ANTLR start "entryRuleEntity"
    // InternalDatamodel.g:78:1: entryRuleEntity : ruleEntity EOF ;
    public final void entryRuleEntity() throws RecognitionException {
        try {
            // InternalDatamodel.g:79:1: ( ruleEntity EOF )
            // InternalDatamodel.g:80:1: ruleEntity EOF
            {
             before(grammarAccess.getEntityRule()); 
            pushFollow(FOLLOW_1);
            ruleEntity();

            state._fsp--;

             after(grammarAccess.getEntityRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleEntity"


    // $ANTLR start "ruleEntity"
    // InternalDatamodel.g:87:1: ruleEntity : ( ( rule__Entity__Group__0 ) ) ;
    public final void ruleEntity() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:91:2: ( ( ( rule__Entity__Group__0 ) ) )
            // InternalDatamodel.g:92:2: ( ( rule__Entity__Group__0 ) )
            {
            // InternalDatamodel.g:92:2: ( ( rule__Entity__Group__0 ) )
            // InternalDatamodel.g:93:3: ( rule__Entity__Group__0 )
            {
             before(grammarAccess.getEntityAccess().getGroup()); 
            // InternalDatamodel.g:94:3: ( rule__Entity__Group__0 )
            // InternalDatamodel.g:94:4: rule__Entity__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Entity__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getEntityAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleEntity"


    // $ANTLR start "rule__Context__Group__0"
    // InternalDatamodel.g:102:1: rule__Context__Group__0 : rule__Context__Group__0__Impl rule__Context__Group__1 ;
    public final void rule__Context__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:106:1: ( rule__Context__Group__0__Impl rule__Context__Group__1 )
            // InternalDatamodel.g:107:2: rule__Context__Group__0__Impl rule__Context__Group__1
            {
            pushFollow(FOLLOW_3);
            rule__Context__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__0"


    // $ANTLR start "rule__Context__Group__0__Impl"
    // InternalDatamodel.g:114:1: rule__Context__Group__0__Impl : ( 'context' ) ;
    public final void rule__Context__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:118:1: ( ( 'context' ) )
            // InternalDatamodel.g:119:1: ( 'context' )
            {
            // InternalDatamodel.g:119:1: ( 'context' )
            // InternalDatamodel.g:120:2: 'context'
            {
             before(grammarAccess.getContextAccess().getContextKeyword_0()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getContextKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__0__Impl"


    // $ANTLR start "rule__Context__Group__1"
    // InternalDatamodel.g:129:1: rule__Context__Group__1 : rule__Context__Group__1__Impl rule__Context__Group__2 ;
    public final void rule__Context__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:133:1: ( rule__Context__Group__1__Impl rule__Context__Group__2 )
            // InternalDatamodel.g:134:2: rule__Context__Group__1__Impl rule__Context__Group__2
            {
            pushFollow(FOLLOW_4);
            rule__Context__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__1"


    // $ANTLR start "rule__Context__Group__1__Impl"
    // InternalDatamodel.g:141:1: rule__Context__Group__1__Impl : ( ( rule__Context__NameAssignment_1 ) ) ;
    public final void rule__Context__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:145:1: ( ( ( rule__Context__NameAssignment_1 ) ) )
            // InternalDatamodel.g:146:1: ( ( rule__Context__NameAssignment_1 ) )
            {
            // InternalDatamodel.g:146:1: ( ( rule__Context__NameAssignment_1 ) )
            // InternalDatamodel.g:147:2: ( rule__Context__NameAssignment_1 )
            {
             before(grammarAccess.getContextAccess().getNameAssignment_1()); 
            // InternalDatamodel.g:148:2: ( rule__Context__NameAssignment_1 )
            // InternalDatamodel.g:148:3: rule__Context__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Context__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getContextAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__1__Impl"


    // $ANTLR start "rule__Context__Group__2"
    // InternalDatamodel.g:156:1: rule__Context__Group__2 : rule__Context__Group__2__Impl rule__Context__Group__3 ;
    public final void rule__Context__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:160:1: ( rule__Context__Group__2__Impl rule__Context__Group__3 )
            // InternalDatamodel.g:161:2: rule__Context__Group__2__Impl rule__Context__Group__3
            {
            pushFollow(FOLLOW_4);
            rule__Context__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__2"


    // $ANTLR start "rule__Context__Group__2__Impl"
    // InternalDatamodel.g:168:1: rule__Context__Group__2__Impl : ( ( rule__Context__Group_2__0 )? ) ;
    public final void rule__Context__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:172:1: ( ( ( rule__Context__Group_2__0 )? ) )
            // InternalDatamodel.g:173:1: ( ( rule__Context__Group_2__0 )? )
            {
            // InternalDatamodel.g:173:1: ( ( rule__Context__Group_2__0 )? )
            // InternalDatamodel.g:174:2: ( rule__Context__Group_2__0 )?
            {
             before(grammarAccess.getContextAccess().getGroup_2()); 
            // InternalDatamodel.g:175:2: ( rule__Context__Group_2__0 )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==17) ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // InternalDatamodel.g:175:3: rule__Context__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Context__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getContextAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__2__Impl"


    // $ANTLR start "rule__Context__Group__3"
    // InternalDatamodel.g:183:1: rule__Context__Group__3 : rule__Context__Group__3__Impl rule__Context__Group__4 ;
    public final void rule__Context__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:187:1: ( rule__Context__Group__3__Impl rule__Context__Group__4 )
            // InternalDatamodel.g:188:2: rule__Context__Group__3__Impl rule__Context__Group__4
            {
            pushFollow(FOLLOW_5);
            rule__Context__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__3"


    // $ANTLR start "rule__Context__Group__3__Impl"
    // InternalDatamodel.g:195:1: rule__Context__Group__3__Impl : ( '{' ) ;
    public final void rule__Context__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:199:1: ( ( '{' ) )
            // InternalDatamodel.g:200:1: ( '{' )
            {
            // InternalDatamodel.g:200:1: ( '{' )
            // InternalDatamodel.g:201:2: '{'
            {
             before(grammarAccess.getContextAccess().getLeftCurlyBracketKeyword_3()); 
            match(input,15,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getLeftCurlyBracketKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__3__Impl"


    // $ANTLR start "rule__Context__Group__4"
    // InternalDatamodel.g:210:1: rule__Context__Group__4 : rule__Context__Group__4__Impl rule__Context__Group__5 ;
    public final void rule__Context__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:214:1: ( rule__Context__Group__4__Impl rule__Context__Group__5 )
            // InternalDatamodel.g:215:2: rule__Context__Group__4__Impl rule__Context__Group__5
            {
            pushFollow(FOLLOW_5);
            rule__Context__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__4"


    // $ANTLR start "rule__Context__Group__4__Impl"
    // InternalDatamodel.g:222:1: rule__Context__Group__4__Impl : ( ( rule__Context__Group_4__0 )? ) ;
    public final void rule__Context__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:226:1: ( ( ( rule__Context__Group_4__0 )? ) )
            // InternalDatamodel.g:227:1: ( ( rule__Context__Group_4__0 )? )
            {
            // InternalDatamodel.g:227:1: ( ( rule__Context__Group_4__0 )? )
            // InternalDatamodel.g:228:2: ( rule__Context__Group_4__0 )?
            {
             before(grammarAccess.getContextAccess().getGroup_4()); 
            // InternalDatamodel.g:229:2: ( rule__Context__Group_4__0 )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==18) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // InternalDatamodel.g:229:3: rule__Context__Group_4__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Context__Group_4__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getContextAccess().getGroup_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__4__Impl"


    // $ANTLR start "rule__Context__Group__5"
    // InternalDatamodel.g:237:1: rule__Context__Group__5 : rule__Context__Group__5__Impl ;
    public final void rule__Context__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:241:1: ( rule__Context__Group__5__Impl )
            // InternalDatamodel.g:242:2: rule__Context__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Context__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__5"


    // $ANTLR start "rule__Context__Group__5__Impl"
    // InternalDatamodel.g:248:1: rule__Context__Group__5__Impl : ( '}' ) ;
    public final void rule__Context__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:252:1: ( ( '}' ) )
            // InternalDatamodel.g:253:1: ( '}' )
            {
            // InternalDatamodel.g:253:1: ( '}' )
            // InternalDatamodel.g:254:2: '}'
            {
             before(grammarAccess.getContextAccess().getRightCurlyBracketKeyword_5()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getRightCurlyBracketKeyword_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group__5__Impl"


    // $ANTLR start "rule__Context__Group_2__0"
    // InternalDatamodel.g:264:1: rule__Context__Group_2__0 : rule__Context__Group_2__0__Impl rule__Context__Group_2__1 ;
    public final void rule__Context__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:268:1: ( rule__Context__Group_2__0__Impl rule__Context__Group_2__1 )
            // InternalDatamodel.g:269:2: rule__Context__Group_2__0__Impl rule__Context__Group_2__1
            {
            pushFollow(FOLLOW_3);
            rule__Context__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_2__0"


    // $ANTLR start "rule__Context__Group_2__0__Impl"
    // InternalDatamodel.g:276:1: rule__Context__Group_2__0__Impl : ( 'extends' ) ;
    public final void rule__Context__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:280:1: ( ( 'extends' ) )
            // InternalDatamodel.g:281:1: ( 'extends' )
            {
            // InternalDatamodel.g:281:1: ( 'extends' )
            // InternalDatamodel.g:282:2: 'extends'
            {
             before(grammarAccess.getContextAccess().getExtendsKeyword_2_0()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getExtendsKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_2__0__Impl"


    // $ANTLR start "rule__Context__Group_2__1"
    // InternalDatamodel.g:291:1: rule__Context__Group_2__1 : rule__Context__Group_2__1__Impl ;
    public final void rule__Context__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:295:1: ( rule__Context__Group_2__1__Impl )
            // InternalDatamodel.g:296:2: rule__Context__Group_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Context__Group_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_2__1"


    // $ANTLR start "rule__Context__Group_2__1__Impl"
    // InternalDatamodel.g:302:1: rule__Context__Group_2__1__Impl : ( ( rule__Context__ParentContextAssignment_2_1 ) ) ;
    public final void rule__Context__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:306:1: ( ( ( rule__Context__ParentContextAssignment_2_1 ) ) )
            // InternalDatamodel.g:307:1: ( ( rule__Context__ParentContextAssignment_2_1 ) )
            {
            // InternalDatamodel.g:307:1: ( ( rule__Context__ParentContextAssignment_2_1 ) )
            // InternalDatamodel.g:308:2: ( rule__Context__ParentContextAssignment_2_1 )
            {
             before(grammarAccess.getContextAccess().getParentContextAssignment_2_1()); 
            // InternalDatamodel.g:309:2: ( rule__Context__ParentContextAssignment_2_1 )
            // InternalDatamodel.g:309:3: rule__Context__ParentContextAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Context__ParentContextAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getContextAccess().getParentContextAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_2__1__Impl"


    // $ANTLR start "rule__Context__Group_4__0"
    // InternalDatamodel.g:318:1: rule__Context__Group_4__0 : rule__Context__Group_4__0__Impl rule__Context__Group_4__1 ;
    public final void rule__Context__Group_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:322:1: ( rule__Context__Group_4__0__Impl rule__Context__Group_4__1 )
            // InternalDatamodel.g:323:2: rule__Context__Group_4__0__Impl rule__Context__Group_4__1
            {
            pushFollow(FOLLOW_6);
            rule__Context__Group_4__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group_4__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_4__0"


    // $ANTLR start "rule__Context__Group_4__0__Impl"
    // InternalDatamodel.g:330:1: rule__Context__Group_4__0__Impl : ( 'entity-catalog' ) ;
    public final void rule__Context__Group_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:334:1: ( ( 'entity-catalog' ) )
            // InternalDatamodel.g:335:1: ( 'entity-catalog' )
            {
            // InternalDatamodel.g:335:1: ( 'entity-catalog' )
            // InternalDatamodel.g:336:2: 'entity-catalog'
            {
             before(grammarAccess.getContextAccess().getEntityCatalogKeyword_4_0()); 
            match(input,18,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getEntityCatalogKeyword_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_4__0__Impl"


    // $ANTLR start "rule__Context__Group_4__1"
    // InternalDatamodel.g:345:1: rule__Context__Group_4__1 : rule__Context__Group_4__1__Impl rule__Context__Group_4__2 ;
    public final void rule__Context__Group_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:349:1: ( rule__Context__Group_4__1__Impl rule__Context__Group_4__2 )
            // InternalDatamodel.g:350:2: rule__Context__Group_4__1__Impl rule__Context__Group_4__2
            {
            pushFollow(FOLLOW_7);
            rule__Context__Group_4__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group_4__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_4__1"


    // $ANTLR start "rule__Context__Group_4__1__Impl"
    // InternalDatamodel.g:357:1: rule__Context__Group_4__1__Impl : ( '{' ) ;
    public final void rule__Context__Group_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:361:1: ( ( '{' ) )
            // InternalDatamodel.g:362:1: ( '{' )
            {
            // InternalDatamodel.g:362:1: ( '{' )
            // InternalDatamodel.g:363:2: '{'
            {
             before(grammarAccess.getContextAccess().getLeftCurlyBracketKeyword_4_1()); 
            match(input,15,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getLeftCurlyBracketKeyword_4_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_4__1__Impl"


    // $ANTLR start "rule__Context__Group_4__2"
    // InternalDatamodel.g:372:1: rule__Context__Group_4__2 : rule__Context__Group_4__2__Impl rule__Context__Group_4__3 ;
    public final void rule__Context__Group_4__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:376:1: ( rule__Context__Group_4__2__Impl rule__Context__Group_4__3 )
            // InternalDatamodel.g:377:2: rule__Context__Group_4__2__Impl rule__Context__Group_4__3
            {
            pushFollow(FOLLOW_7);
            rule__Context__Group_4__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Context__Group_4__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_4__2"


    // $ANTLR start "rule__Context__Group_4__2__Impl"
    // InternalDatamodel.g:384:1: rule__Context__Group_4__2__Impl : ( ( rule__Context__EntitiesAssignment_4_2 )* ) ;
    public final void rule__Context__Group_4__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:388:1: ( ( ( rule__Context__EntitiesAssignment_4_2 )* ) )
            // InternalDatamodel.g:389:1: ( ( rule__Context__EntitiesAssignment_4_2 )* )
            {
            // InternalDatamodel.g:389:1: ( ( rule__Context__EntitiesAssignment_4_2 )* )
            // InternalDatamodel.g:390:2: ( rule__Context__EntitiesAssignment_4_2 )*
            {
             before(grammarAccess.getContextAccess().getEntitiesAssignment_4_2()); 
            // InternalDatamodel.g:391:2: ( rule__Context__EntitiesAssignment_4_2 )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0==RULE_ID) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // InternalDatamodel.g:391:3: rule__Context__EntitiesAssignment_4_2
            	    {
            	    pushFollow(FOLLOW_8);
            	    rule__Context__EntitiesAssignment_4_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);

             after(grammarAccess.getContextAccess().getEntitiesAssignment_4_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_4__2__Impl"


    // $ANTLR start "rule__Context__Group_4__3"
    // InternalDatamodel.g:399:1: rule__Context__Group_4__3 : rule__Context__Group_4__3__Impl ;
    public final void rule__Context__Group_4__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:403:1: ( rule__Context__Group_4__3__Impl )
            // InternalDatamodel.g:404:2: rule__Context__Group_4__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Context__Group_4__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_4__3"


    // $ANTLR start "rule__Context__Group_4__3__Impl"
    // InternalDatamodel.g:410:1: rule__Context__Group_4__3__Impl : ( '}' ) ;
    public final void rule__Context__Group_4__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:414:1: ( ( '}' ) )
            // InternalDatamodel.g:415:1: ( '}' )
            {
            // InternalDatamodel.g:415:1: ( '}' )
            // InternalDatamodel.g:416:2: '}'
            {
             before(grammarAccess.getContextAccess().getRightCurlyBracketKeyword_4_3()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getRightCurlyBracketKeyword_4_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__Group_4__3__Impl"


    // $ANTLR start "rule__Entity__Group__0"
    // InternalDatamodel.g:426:1: rule__Entity__Group__0 : rule__Entity__Group__0__Impl rule__Entity__Group__1 ;
    public final void rule__Entity__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:430:1: ( rule__Entity__Group__0__Impl rule__Entity__Group__1 )
            // InternalDatamodel.g:431:2: rule__Entity__Group__0__Impl rule__Entity__Group__1
            {
            pushFollow(FOLLOW_9);
            rule__Entity__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Entity__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__Group__0"


    // $ANTLR start "rule__Entity__Group__0__Impl"
    // InternalDatamodel.g:438:1: rule__Entity__Group__0__Impl : ( ( rule__Entity__NameAssignment_0 ) ) ;
    public final void rule__Entity__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:442:1: ( ( ( rule__Entity__NameAssignment_0 ) ) )
            // InternalDatamodel.g:443:1: ( ( rule__Entity__NameAssignment_0 ) )
            {
            // InternalDatamodel.g:443:1: ( ( rule__Entity__NameAssignment_0 ) )
            // InternalDatamodel.g:444:2: ( rule__Entity__NameAssignment_0 )
            {
             before(grammarAccess.getEntityAccess().getNameAssignment_0()); 
            // InternalDatamodel.g:445:2: ( rule__Entity__NameAssignment_0 )
            // InternalDatamodel.g:445:3: rule__Entity__NameAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__Entity__NameAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getEntityAccess().getNameAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__Group__0__Impl"


    // $ANTLR start "rule__Entity__Group__1"
    // InternalDatamodel.g:453:1: rule__Entity__Group__1 : rule__Entity__Group__1__Impl ;
    public final void rule__Entity__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:457:1: ( rule__Entity__Group__1__Impl )
            // InternalDatamodel.g:458:2: rule__Entity__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Entity__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__Group__1"


    // $ANTLR start "rule__Entity__Group__1__Impl"
    // InternalDatamodel.g:464:1: rule__Entity__Group__1__Impl : ( ( rule__Entity__Group_1__0 )? ) ;
    public final void rule__Entity__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:468:1: ( ( ( rule__Entity__Group_1__0 )? ) )
            // InternalDatamodel.g:469:1: ( ( rule__Entity__Group_1__0 )? )
            {
            // InternalDatamodel.g:469:1: ( ( rule__Entity__Group_1__0 )? )
            // InternalDatamodel.g:470:2: ( rule__Entity__Group_1__0 )?
            {
             before(grammarAccess.getEntityAccess().getGroup_1()); 
            // InternalDatamodel.g:471:2: ( rule__Entity__Group_1__0 )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==17) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // InternalDatamodel.g:471:3: rule__Entity__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Entity__Group_1__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getEntityAccess().getGroup_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__Group__1__Impl"


    // $ANTLR start "rule__Entity__Group_1__0"
    // InternalDatamodel.g:480:1: rule__Entity__Group_1__0 : rule__Entity__Group_1__0__Impl rule__Entity__Group_1__1 ;
    public final void rule__Entity__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:484:1: ( rule__Entity__Group_1__0__Impl rule__Entity__Group_1__1 )
            // InternalDatamodel.g:485:2: rule__Entity__Group_1__0__Impl rule__Entity__Group_1__1
            {
            pushFollow(FOLLOW_10);
            rule__Entity__Group_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Entity__Group_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__Group_1__0"


    // $ANTLR start "rule__Entity__Group_1__0__Impl"
    // InternalDatamodel.g:492:1: rule__Entity__Group_1__0__Impl : ( 'extends' ) ;
    public final void rule__Entity__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:496:1: ( ( 'extends' ) )
            // InternalDatamodel.g:497:1: ( 'extends' )
            {
            // InternalDatamodel.g:497:1: ( 'extends' )
            // InternalDatamodel.g:498:2: 'extends'
            {
             before(grammarAccess.getEntityAccess().getExtendsKeyword_1_0()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getEntityAccess().getExtendsKeyword_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__Group_1__0__Impl"


    // $ANTLR start "rule__Entity__Group_1__1"
    // InternalDatamodel.g:507:1: rule__Entity__Group_1__1 : rule__Entity__Group_1__1__Impl ;
    public final void rule__Entity__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:511:1: ( rule__Entity__Group_1__1__Impl )
            // InternalDatamodel.g:512:2: rule__Entity__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Entity__Group_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__Group_1__1"


    // $ANTLR start "rule__Entity__Group_1__1__Impl"
    // InternalDatamodel.g:518:1: rule__Entity__Group_1__1__Impl : ( ( rule__Entity__ParentEntityAssignment_1_1 ) ) ;
    public final void rule__Entity__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:522:1: ( ( ( rule__Entity__ParentEntityAssignment_1_1 ) ) )
            // InternalDatamodel.g:523:1: ( ( rule__Entity__ParentEntityAssignment_1_1 ) )
            {
            // InternalDatamodel.g:523:1: ( ( rule__Entity__ParentEntityAssignment_1_1 ) )
            // InternalDatamodel.g:524:2: ( rule__Entity__ParentEntityAssignment_1_1 )
            {
             before(grammarAccess.getEntityAccess().getParentEntityAssignment_1_1()); 
            // InternalDatamodel.g:525:2: ( rule__Entity__ParentEntityAssignment_1_1 )
            // InternalDatamodel.g:525:3: rule__Entity__ParentEntityAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__Entity__ParentEntityAssignment_1_1();

            state._fsp--;


            }

             after(grammarAccess.getEntityAccess().getParentEntityAssignment_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__Group_1__1__Impl"


    // $ANTLR start "rule__Context__NameAssignment_1"
    // InternalDatamodel.g:534:1: rule__Context__NameAssignment_1 : ( RULE_CTXT_FQN ) ;
    public final void rule__Context__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:538:1: ( ( RULE_CTXT_FQN ) )
            // InternalDatamodel.g:539:2: ( RULE_CTXT_FQN )
            {
            // InternalDatamodel.g:539:2: ( RULE_CTXT_FQN )
            // InternalDatamodel.g:540:3: RULE_CTXT_FQN
            {
             before(grammarAccess.getContextAccess().getNameCTXT_FQNTerminalRuleCall_1_0()); 
            match(input,RULE_CTXT_FQN,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getNameCTXT_FQNTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__NameAssignment_1"


    // $ANTLR start "rule__Context__ParentContextAssignment_2_1"
    // InternalDatamodel.g:549:1: rule__Context__ParentContextAssignment_2_1 : ( ( RULE_CTXT_FQN ) ) ;
    public final void rule__Context__ParentContextAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:553:1: ( ( ( RULE_CTXT_FQN ) ) )
            // InternalDatamodel.g:554:2: ( ( RULE_CTXT_FQN ) )
            {
            // InternalDatamodel.g:554:2: ( ( RULE_CTXT_FQN ) )
            // InternalDatamodel.g:555:3: ( RULE_CTXT_FQN )
            {
             before(grammarAccess.getContextAccess().getParentContextContextCrossReference_2_1_0()); 
            // InternalDatamodel.g:556:3: ( RULE_CTXT_FQN )
            // InternalDatamodel.g:557:4: RULE_CTXT_FQN
            {
             before(grammarAccess.getContextAccess().getParentContextContextCTXT_FQNTerminalRuleCall_2_1_0_1()); 
            match(input,RULE_CTXT_FQN,FOLLOW_2); 
             after(grammarAccess.getContextAccess().getParentContextContextCTXT_FQNTerminalRuleCall_2_1_0_1()); 

            }

             after(grammarAccess.getContextAccess().getParentContextContextCrossReference_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__ParentContextAssignment_2_1"


    // $ANTLR start "rule__Context__EntitiesAssignment_4_2"
    // InternalDatamodel.g:568:1: rule__Context__EntitiesAssignment_4_2 : ( ruleEntity ) ;
    public final void rule__Context__EntitiesAssignment_4_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:572:1: ( ( ruleEntity ) )
            // InternalDatamodel.g:573:2: ( ruleEntity )
            {
            // InternalDatamodel.g:573:2: ( ruleEntity )
            // InternalDatamodel.g:574:3: ruleEntity
            {
             before(grammarAccess.getContextAccess().getEntitiesEntityParserRuleCall_4_2_0()); 
            pushFollow(FOLLOW_2);
            ruleEntity();

            state._fsp--;

             after(grammarAccess.getContextAccess().getEntitiesEntityParserRuleCall_4_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Context__EntitiesAssignment_4_2"


    // $ANTLR start "rule__Entity__NameAssignment_0"
    // InternalDatamodel.g:583:1: rule__Entity__NameAssignment_0 : ( RULE_ID ) ;
    public final void rule__Entity__NameAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:587:1: ( ( RULE_ID ) )
            // InternalDatamodel.g:588:2: ( RULE_ID )
            {
            // InternalDatamodel.g:588:2: ( RULE_ID )
            // InternalDatamodel.g:589:3: RULE_ID
            {
             before(grammarAccess.getEntityAccess().getNameIDTerminalRuleCall_0_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getEntityAccess().getNameIDTerminalRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__NameAssignment_0"


    // $ANTLR start "rule__Entity__ParentEntityAssignment_1_1"
    // InternalDatamodel.g:598:1: rule__Entity__ParentEntityAssignment_1_1 : ( ( RULE_GENERAL_FQN ) ) ;
    public final void rule__Entity__ParentEntityAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalDatamodel.g:602:1: ( ( ( RULE_GENERAL_FQN ) ) )
            // InternalDatamodel.g:603:2: ( ( RULE_GENERAL_FQN ) )
            {
            // InternalDatamodel.g:603:2: ( ( RULE_GENERAL_FQN ) )
            // InternalDatamodel.g:604:3: ( RULE_GENERAL_FQN )
            {
             before(grammarAccess.getEntityAccess().getParentEntityEntityCrossReference_1_1_0()); 
            // InternalDatamodel.g:605:3: ( RULE_GENERAL_FQN )
            // InternalDatamodel.g:606:4: RULE_GENERAL_FQN
            {
             before(grammarAccess.getEntityAccess().getParentEntityEntityGENERAL_FQNTerminalRuleCall_1_1_0_1()); 
            match(input,RULE_GENERAL_FQN,FOLLOW_2); 
             after(grammarAccess.getEntityAccess().getParentEntityEntityGENERAL_FQNTerminalRuleCall_1_1_0_1()); 

            }

             after(grammarAccess.getEntityAccess().getParentEntityEntityCrossReference_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Entity__ParentEntityAssignment_1_1"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000028000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000050000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000010020L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000000022L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000000040L});

}